regexp comparison bug

10/26/2011 02:08 AM - ddebernardy (Denis de Bernardy)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

Description

Based on ri Regexp.eql?:

Equality---Two regexps are equal if their patterns are identical, they have

the same character set code, and their casefold? values are the same.

/abc/  == /abc/x   #=> false

/abc/  == /abc/i   #=> false

/abc/  == /abc/n   #=> false

/abc/u == /abc/n   #=> false

However:

a = Regexp.new("/foo")

=> //foo/

b = //foo/

=> //foo/

a == b

=> false

 

The only meaningful difference between the two is the exact source:

a.source

=> "/foo"

b.source

=> "\/foo"

 

But I'd argue that a's source should be normalized to that of b, or vice-versa, since their string representations are identical.

Associated revisions

Revision 68a16f9a2dfbb773744adaa63468449838761015 - 03/04/2012 02:21 PM - nobu (Nobuyoshi Nakada)

parse.y (parser_tokadd_string): regexp engine doesn't need

terminators to be escaped.  [ruby-core:40364][Bug #5484]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34896 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 68a16f9a - 03/04/2012 02:21 PM - nobu (Nobuyoshi Nakada)

parse.y (parser_tokadd_string): regexp engine doesn't need

terminators to be escaped.  [ruby-core:40364][Bug #5484]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34896 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/27/2011 03:04 PM - naruse (Yui NARUSE)

- Tracker changed from Bug to Feature

I think this is from a policy of comparison, not a bug.
If you have a reason that Ruby change the policy, please show us.

We'll change the policy if it is reasonable.

#2 - 03/03/2012 11:03 PM - ddebernardy (Denis de Bernardy)

Well, I originally reported it as a bug, since I got bit by it. I can't recall the context let alone the specifics.

Anyway... Feel free to close if you think this is to be expected (I'd argue it shouldn't...)

#3 - 03/04/2012 11:21 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r34896.

Denis, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
